## lxd.sources1767855872any.cards.tar.xz

=== Makefile ===
DOMAIN=lxd
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot
VERSION=$(or ${CUSTOM_VERSION},$(shell grep "var Version" shared/version/flex.go | cut -d'"' -f2))
ARCHIVE=lxd-$(VERSION).tar
HASH := \#
TAG_SQLITE3=$(shell printf "$(HASH)include <dqlite.h>\nvoid main(){dqlite_node_id n = 1;}" | $(CC) ${CGO_CFLAGS} -o /dev/null -xc - >/dev/null 2>&1 && echo "libsqlite3")
GOPATH ?= $(shell go env GOPATH)
CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)
SPHINXENV=doc/.sphinx/venv/bin/activate
SPHINXPIPPATH=doc/.sphinx/venv/bin/pip
GOMIN=1.25.4
GOTOOLCHAIN=local
export GOTOOLCHAIN
GOCOVERDIR ?= $(shell go env GOCOVERDIR)
ifeq "$(GOCOVERDIR)" ""
	COVER=
	COVER_TEST=
else
	COVER=-cover
	COVER_TEST=-test.gocoverdir="$(GOCOVERDIR)"
endif
ARCH ?= $(shell uname -m)
DQLITE_BRANCH=main
LIBLXC_BRANCH=main

ifneq "$(wildcard vendor)" ""
	DEPS_PATH=$(CURDIR)/vendor
else
	DEPS_PATH=$(GOPATH)/deps
endif
DQLITE_PATH=$(DEPS_PATH)/dqlite
LIBLXC_PATH=$(DEPS_PATH)/liblxc
LIBLXC_ROOTFS_MOUNT_PATH=$(GOPATH)/bin/liblxc/rootfs

export CGO_CFLAGS ?= -I$(DQLITE_PATH)/include/ -I$(LIBLXC_PATH)/include/
export CGO_LDFLAGS ?= -L$(DQLITE_PATH)/.libs/ -L$(LIBLXC_PATH)/lib/$(ARCH)-linux-gnu/
export LD_LIBRARY_PATH ?= $(DQLITE_PATH)/.libs/:$(LIBLXC_PATH)/lib/$(ARCH)-linux-gnu/
export PKG_CONFIG_PATH ?= $(LIBLXC_PATH)/lib/$(ARCH)-linux-gnu/pkgconfig
export CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)

.PHONY: default
default: all

.PHONY: build
build: lxd

.PHONY: all
all: client lxd lxd-agent lxd-benchmark lxd-metadata lxd-migrate lxd-user test-binaries

.PHONY: lxd
lxd:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing dqlite, run \"make deps\" to setup."
	exit 1
endif
	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -v -tags "$(TAG_SQLITE3)" -trimpath $(COVER) $(DEBUG) ./lxd
	@echo "$@ built successfully"

.PHONY: lxd-benchmark
lxd-benchmark:
	CGO_ENABLED=0 go install -v -tags netgo -trimpath $(COVER) $(DEBUG) ./lxd-benchmark
	@echo "$@ built successfully"

.PHONY: lxd-user
lxd-user:
	CGO_ENABLED=0 go install -v -tags netgo -trimpath $(COVER) $(DEBUG) ./lxd-user
	@echo "$@ built successfully"

.PHONY: client
client:
	go install -v -trimpath $(COVER) $(DEBUG) ./lxc
	@echo "LXD $@ built successfully"

.PHONY: lxd-agent
lxd-agent:
	CGO_ENABLED=0 go install -v -trimpath $(COVER) -tags agent,netgo ./lxd-agent
	@echo "$@ built successfully"

.PHONY: lxd-metadata
lxd-metadata:
	CGO_ENABLED=0 go install -v -trimpath $(COVER) -tags lxd-metadata ./lxd/lxd-metadata
	@echo "$@ built successfully"

.PHONY: lxd-migrate
lxd-migrate:
	CGO_ENABLED=0 go install -v -trimpath $(COVER) -tags netgo ./lxd-migrate
	@echo "$@ built successfully"

.PHONY: devlxd-client
devlxd-client:
	CGO_ENABLED=0 go install -C test -v -trimpath -buildvcs=false $(COVER) -tags netgo ./devlxd-client
	@echo "$@ built successfully"

.PHONY: fuidshift
fuidshift:
	go install -v -trimpath -buildvcs=false $(COVER) ./fuidshift
	@echo "$@ built successfully"

.PHONY: mini-oidc
mini-oidc:
	go install -C test -v -trimpath -buildvcs=false $(COVER) ./mini-oidc
	@echo "$@ built successfully"

.PHONY: sysinfo
sysinfo:
	go install -C test -v -trimpath -buildvcs=false $(COVER) ./syscall/sysinfo
	@echo "$@ built successfully"

.PHONY: test-binaries
test-binaries: devlxd-client fuidshift mini-oidc sysinfo
	@echo "$@ built successfully"

.PHONY: dqlite
dqlite:
	# dqlite (+raft)
	@if [ ! -e "$(DQLITE_PATH)" ]; then \
		echo "Retrieving dqlite from ${DQLITE_BRANCH} branch"; \
		git clone --depth=1 --branch "${DQLITE_BRANCH}" "https://github.com/canonical/dqlite" "$(DQLITE_PATH)"; \
	elif [ -e "$(DQLITE_PATH)/.git" ]; then \
		if [ "$(shell git -C "$(DQLITE_PATH)" branch --show-current)" = "master" ]; then \
			echo "Update your local checkout of dqlite to use the 'main' branch instead of the 'master'"; \
			exit 1; \
		fi; \
		echo "Updating existing dqlite branch"; \
		git -C "$(DQLITE_PATH)" pull; \
	fi

	cd "$(DQLITE_PATH)" && \
		autoreconf -i && \
		./configure --enable-build-raft && \
		make -j

ifneq ($(shell command -v ldd),)
	# verify that libdqlite.so is linked against some critically important libs
	ldd "$(DQLITE_PATH)/.libs/libdqlite.so" | grep -wE 'liblz4|libsqlite3|libuv'
	[ "$$(ldd "$(DQLITE_PATH)/.libs/libdqlite.so" | grep -cwE 'liblz4|libsqlite3|libuv')" = "3" ]
	@echo "OK: libdqlite .so link check passed"
endif

.PHONY: liblxc
liblxc:
	# lxc/liblxc
	@if [ ! -e "$(LIBLXC_PATH)" ]; then \
		echo "Retrieving lxc/liblxc from $(LIBLXC_BRANCH) branch"; \
		git clone --depth=1 --branch "${LIBLXC_BRANCH}" "https://github.com/lxc/lxc" "$(LIBLXC_PATH)"; \
	elif [ -e "$(LIBLXC_PATH)/.git" ]; then \
		echo "Updating existing lxc/liblxc branch"; \
		git -C "$(LIBLXC_PATH)" pull; \
	fi

	# XXX: the rootfs-mount-path must not depend on LIBLXC_PATH to allow
	# building in "vendor" mode but move the resulting binaries elsewhere for
	# caching purposes
	cd "$(LIBLXC_PATH)" && \
		meson setup \
			--buildtype=release \
			-Dapparmor=true \
			-Dcapabilities=true \
			-Dcommands=false \
			-Ddbus=false \
			-Dexamples=false \
			-Dinstall-init-files=false \
			-Dinstall-state-dirs=false \
			-Dlibdir="lib/$(ARCH)-linux-gnu" \
			-Dman=false \
			-Dmemfd-rexec=false \
			-Dopenssl=false \
			-Dprefix="$(LIBLXC_PATH)" \
			-Drootfs-mount-path="$(LIBLXC_ROOTFS_MOUNT_PATH)" \
			-Dseccomp=true \
			-Dselinux=false \
			-Dspecfile=false \
			-Dtests=false \
			-Dtools=false \
			build && \
		meson compile -C build && \
		ninja -C build install

ifneq ($(shell command -v ldd),)
	# verify that liblxc.so is linked against some critically important libs
	ldd "$(LIBLXC_PATH)/lib/$(ARCH)-linux-gnu/liblxc.so" | grep -wE 'libapparmor|libcap|libseccomp'
	[ "$$(ldd "$(LIBLXC_PATH)/lib/$(ARCH)-linux-gnu/liblxc.so" | grep -cwE 'libapparmor|libcap|libseccomp')" = "3" ]
	@echo "OK: liblxc .so link check passed"
endif

.PHONY: env
env:
	@echo "export CGO_CFLAGS=\"$(CGO_CFLAGS)\""
	@echo "export CGO_LDFLAGS=\"$(CGO_LDFLAGS)\""
	@echo "export LD_LIBRARY_PATH=\"$(LD_LIBRARY_PATH)\""
	@echo "export PKG_CONFIG_PATH=\"$(PKG_CONFIG_PATH)\""
	@echo "export CGO_LDFLAGS_ALLOW=\"$(CGO_LDFLAGS_ALLOW)\""

.PHONY: deps
deps: dqlite liblxc
	@echo ""
	@echo "# Please set the following in your environment (possibly ~/.bashrc)"
	@$(MAKE) -s env

# Spawns an interactive test shell for quick interactions with LXD and the test
# suite.
.PHONY: test-shell
test-shell:
	@eval "$(MAKE) -s env"
	cd test && exec ./main.sh test-shell

.PHONY: tics
tics: deps
	go build -a -x -v ./...
	CC="cc" CGO_LDFLAGS_ALLOW="(-Wl,-wrap,pthread_create)|(-Wl,-z,now)" go install -v -tags "libsqlite3" -trimpath -a -x -v ./...

.PHONY: check-gomin
check-gomin:
	go mod tidy -go=$(GOMIN)
	@echo "Check the doc mentions the right Go minimum version"
	$(eval DOC_GOMIN := $(shell sed -n 's/^LXD requires Go \([0-9.]\+\) .*/\1/p' doc/requirements.md))
	if [ "$(DOC_GOMIN)" != "$(GOMIN)" ]; then \
		echo "Please update the Go version in 'doc/requirements.md' to be $(GOMIN) instead of $(DOC_GOMIN)"; \
		exit 1; \
	fi
	@echo "Check copilot-instructions.md mentions the right Go minimum version"
	$(eval COPILOT_GOMIN := $(shell sed -n 's/^LXD requires Go \([0-9.]\+\) .*/\1/p' .github/copilot-instructions.md))
	if [ "$(COPILOT_GOMIN)" != "$(GOMIN)" ]; then \
		echo "Please update the Go version in '.github/copilot-instructions.md' to be $(GOMIN) instead of $(COPILOT_GOMIN)"; \
		exit 1; \
	fi

.PHONY: update-gomin
update-gomin:
ifndef NEW_GOMIN
	@echo "Usage: make update-gomin NEW_GOMIN=1.x.y"
	@echo "Current Go minimum version: $(GOMIN)"
	exit 1
endif
ifeq "$(GOMIN)" "$(NEW_GOMIN)"
	@echo "Error: NEW_GOMIN ($(NEW_GOMIN)) is the same as current GOMIN ($(GOMIN))"
	exit 1
endif
	@echo "Updating Go minimum version from $(GOMIN) to $(NEW_GOMIN)"

	@# Update GOMIN in Makefile
	sed -i 's/^GOMIN=[0-9.]\+/GOMIN=$(NEW_GOMIN)/' Makefile

	@# Update GOMIN in go.mod
	sed -i 's/^go [0-9.]\+$$/go $(NEW_GOMIN)/' go.mod

	@# Update doc/requirements.md and .github/copilot-instructions.md
	sed -i 's/^\(LXD requires Go \)[0-9.]\+ /\1$(NEW_GOMIN) /' doc/requirements.md .github/copilot-instructions.md

	@echo "Go minimum version updated to $(NEW_GOMIN)"
	if [ -t 0 ]; then \
		read -rp "Would you like to commit Go version changes (Y/n)? " answer; \
		if [ "$${answer:-y}" = "y" ] || [ "$${answer:-y}" = "Y" ]; then \
			git commit -S -sm "go: Update Go minimum version to $(NEW_GOMIN)" -- Makefile go.mod doc/requirements.md .github/copilot-instructions.md; \
		fi; \
	fi

.PHONY: update-gomod
update-gomod:
ifneq "$(LXD_OFFLINE)" ""
	@echo "The update-gomod target cannot be run in offline mode."
	exit 1
endif
	# Update gomod dependencies
	go get -t -v -u ./...

	# Static pins
	go get github.com/gorilla/websocket@v1.5.1 # Due to riscv64 crashes in LP
	go get tags.cncf.io/container-device-interface@v0.8.1 # Due to incompat with nvidia-container-toolkit
	go get github.com/olekukonko/tablewriter@v0.0.5 # Due to breaking API in later versions

	# Enforce minimum go version
	$(MAKE) check-gomin

	# Use the bundled toolchain that meets the minimum go version
	go get toolchain@none

	@echo "Dependencies updated"
	if [ -t 0 ] && ! git diff --quiet -- ./go.mod ./go.sum; then \
		read -rp "Would you like to commit gomod changes (Y/n)? " answer; \
		if [ "$${answer:-y}" = "y" ] || [ "$${answer:-y}" = "Y" ]; then \
			git commit -S -sm "gomod: Update dependencies" -- ./go.mod ./go.sum; \
		fi; \
	fi


.PHONY: update-protobuf
update-protobuf:
	protoc --go_out=. ./lxd/migration/migrate.proto

.PHONY: update-schema
update-schema:
	@# XXX: `go install ...@latest` is almost a noop if already up to date
	go install golang.org/x/tools/cmd/goimports@latest
	go build -C lxd/db/generate -v -trimpath -o $(GOPATH)/bin/lxd-generate -tags "$(TAG_SQLITE3)" $(DEBUG)
	go generate ./...
	@echo "Code generation completed"

.PHONY: update-api
update-api:
ifeq "$(LXD_OFFLINE)" ""
	go install github.com/go-swagger/go-swagger/cmd/swagger@latest
endif
	@# Generate spec and exclude package from dependency which causes a 'classifier: unknown swagger annotation "extendee"' error.
	@# For more details see: https://github.com/go-swagger/go-swagger/issues/2917.
	swagger generate spec -o doc/rest-api.yaml -w ./lxd -m -x github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-openapiv2/options
	if [ -t 0 ] && ! git diff --quiet -- ./doc/rest-api.yaml; then \
		read -rp "Would you like to commit swagger YAML changes (Y/n)? " answer; \
		if [ "$${answer:-y}" = "y" ] || [ "$${answer:-y}" = "Y" ]; then \
			git commit -S -sm "doc/rest-api: Refresh swagger YAML" -- ./doc/rest-api.yaml; \
		fi; \
	fi

.PHONY: update-metadata
update-metadata: lxd-metadata
	@echo "Generating golang documentation metadata"
	$(GOPATH)/bin/lxd-metadata . --json ./lxd/metadata/configuration.json --txt ./doc/metadata.txt --substitution-db ./doc/substitutions.yaml
	if [ -t 0 ] && ! git diff --quiet -- ./lxd/metadata/configuration.json ./doc/metadata.txt; then \
		read -rp "Would you like to commit metadata changes (Y/n)? " answer; \
		if [ "$${answer:-y}" = "y" ] || [ "$${answer:-y}" = "Y" ]; then \
			git commit -S -sm "doc: Update metadata" -- ./lxd/metadata/configuration.json ./doc/metadata.txt; \
		fi; \
	fi

.PHONY: update-godeps
update-godeps:
	@echo "Updating godeps.list files"
	@UPDATE_LISTS=true test/lint/godeps.sh

.PHONY: doc
doc: doc-clean doc-install doc-html doc-objects

.PHONY: doc-incremental
doc-incremental: doc-html

doc-%:
	$(MAKE) -C doc -f Makefile $*

.PHONY: debug
debug:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" go install -v -tags "$(TAG_SQLITE3) logdebug" $(DEBUG) ./...
	CGO_ENABLED=0 go install -v -trimpath -tags "netgo,logdebug" ./lxd-migrate
	CGO_ENABLED=0 go install -v -trimpath -tags "agent,netgo,logdebug" ./lxd-agent
	@echo "LXD built successfully"

.PHONY: check

=== vendor/liblxc/meson_options.txt ===
# -*- mode: meson -*-

# Main options
# was --cgroup-pattern in autotools
option('cgroup-pattern', type: 'string', value: '',
       description: 'CGroup pattern')

# was --coverity-build in autotools
option('coverity-build', type: 'boolean', value: true,
       description: 'build for coverity')

# was --{disable,enable}-examples in autotools
option('examples', type: 'boolean', value: true,
       description: 'build and install examples')

# was --init-script in autotools
option('init-script', type: 'array',
       choices: ['systemd', 'sysvinit'], value: ['systemd'],
       description: 'init script')

# was --systemd-unidir in autotools
# If set to "", the value is taken from the running systemd instance.
option('systemd-unitdir', type: 'string', value: '',
       description: 'systemd system unit directory')

# was --{disable,enable}-liburing in autotools
option('io-uring-event-loop', type: 'boolean', value: false,
       description: 'Enable io-uring based event loop')

# was --{disable,enable}-doc in autotools
option('man', type: 'boolean', value: true,
       description: 'build and install manpages')

# was --{disable,enable}-pam in autotools
option('pam-cgroup', type: 'boolean', value: false,
       description: 'build and install the pam cgroup module')

# was --{disable,enable}-tools in autotools
option('tools', type: 'boolean', value: true,
       description: 'build and install tools')

option('tools-multicall', type: 'boolean', value: false,
       description: 'build and install busybox style multicall binary')

# was --{disable,enable}-commands in autotools
option('commands', type: 'boolean', value: true,
       description: 'build and install commands')

# was --{disable,enable}-capabilities in autotools
option('capabilities', type: 'boolean', value: true,
       description: 'use capabilities')

# was --{disable,enable}-seccomp in autotools
option('seccomp', type: 'boolean', value: true,
       description: 'use seccomp')

# was --{disable,enable}-apparmor in autotools
option('apparmor', type: 'boolean', value: true,
       description: 'use apparmor')

# was --{disable,enable}-openssl in autotools
option('openssl', type: 'boolean', value: true,
       description: 'use openssl')

# was --{disable,enable}-selinux in autotools
option('selinux', type: 'boolean', value: true,
       description: 'use selinux')

# was --{disable,enable}-tests in autotools
option('tests', type: 'boolean', value: false,
       description: 'build and install tests')

# Paths
# was --apparmor-cache-dir in autotools
option('apparmor-cache-path', type: 'string', value: 'cache/lxc/apparmor',
       description: 'AppArmor cache directory')

# was --with-config-path in autotools
option('data-path', type: 'string', value: 'lib/lxc',
       description: 'Container storage directory')

# was --with-doc-dir in autotools
option('doc-path', type: 'string', value: 'doc/lxc',
       description: 'Documentation directory')

# was --with-global-conf in autotools
option('global-config-path', type: 'string', value: 'lxc',
       description: 'Global configuration directory')

# was --log-path in autotools
option('log-path', type: 'string', value: 'log/lxc',
       description: 'Loging directory')

# was --with-rootfs-path in autotools
option('rootfs-mount-path', type: 'string', value: 'lxc/rootfs',
       description: 'Container rootfs mount directory')

# was --with-runtime-path in autotools
option('runtime-path', type: 'string', value: '/run',
       description: 'Main runtime directory')

# was --with-usernic-conf in autotools
option('usernet-config-path', type: 'string', value: 'lxc/lxc-usernet',
       description: 'User network configuration file path')

# was --with-usernic-db in autotools
option('usernet-db-path', type: 'string', value: 'lxc/nics',
       description: 'User network database file path')

option('oss-fuzz', type: 'boolean', value: false,
       description: 'build against oss-fuzz')

# was --{disable,enable}-thread-safety in autotools
option('thread-safety', type: 'boolean', value: true,
       description: 'whether the build fails when thread-safe logging cannot be guaranteed')

# was --{disable,enable}-memfd-rexec in autotools
option('memfd-rexec', type: 'boolean', value: true,
       description: 'whether to rexec the lxc-attach binary when attaching to a container')

option('distrosysconfdir', type: 'string', value: '',
       description: 'relative path to sysconfdir for distro default configuration')

option('dbus', type: 'boolean', value: true,
       description: 'use dbus')

option('landlock-monitor', type: 'boolean', value: false,
       description: 'use Landlock to protect the monitor API')

option('specfile', type: 'boolean', value: true,
       description: 'whether to prepare RPM spec')

option('install-init-files', type: 'boolean', value: true,
       description: 'whether to install init files for local init (e.g. systemd units)')

option('install-state-dirs', type: 'boolean', value: true,
       description: 'whether to create state directories on install')

=== vendor/dqlite/debian/control ===
Source: dqlite1.18-unstable
Section: devel
Priority: optional
Maintainer: Marco Manino <marco.manino@canonical.com>
Build-Depends: debhelper (>= 10),
               pkgconf,
               libsqlite3-dev,
               libuv1-dev,
               liblz4-dev,
               xfslibs-dev
Homepage: https://github.com/canonical/dqlite
Standards-Version: 4.5.1
Rules-Requires-Root: no

Package: libdqlite1.18-unstable-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: Distributed SQLite database using Raft - library
 libdqlite is a SQLite and Raft based distributed database.
 .
 This package contains the library itself.

Package: libdqlite1.18-unstable-dev
Section: libdevel
Architecture: any
Depends: libdqlite1.18-unstable-0 (= ${binary:Version}),
         ${misc:Depends},
         libsqlite3-dev,
         libuv1-dev,
         liblz4-dev
Multi-Arch: same
Description: Distributed SQLite database using Raft - library
 libdqlite is a SQLite and Raft based distributed database.
 .
 This package contains the development files (headers, static libraries)
